/**
 * DevExtreme (esm/renovation/ui/scheduler/props.js)
 * Version: 22.2.6 (build 23134-0310)
 * Build date: Sun May 14 2023
 *
 * Copyright (c) 2012 - 2023 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
import _extends from "@babel/runtime/helpers/esm/extends";
import messageLocalization from "../../../localization/message";
import {
    BaseWidgetProps
} from "../common/base_props";
export var ScrollingProps = {};
export var ResourceProps = {};
export var ViewProps = {};
export var AppointmentEditingProps = {};
export var AppointmentDraggingProps = {};
export var SchedulerProps = Object.create(Object.prototype, _extends(Object.getOwnPropertyDescriptors(BaseWidgetProps), Object.getOwnPropertyDescriptors({
    adaptivityEnabled: false,
    crossScrollingEnabled: false,
    descriptionExpr: "description",
    editing: Object.freeze({
        allowAdding: true,
        allowDeleting: true,
        allowDragging: true,
        allowResizing: true,
        allowUpdating: true,
        allowTimeZoneEditing: false
    }),
    focusStateEnabled: true,
    groupByDate: false,
    indicatorUpdateInterval: 3e5,
    get noDataText() {
        return messageLocalization.format("dxCollectionWidget-noDataText")
    },
    recurrenceEditMode: "dialog",
    remoteFiltering: false,
    resources: Object.freeze([]),
    scrolling: Object.freeze({
        mode: "standard"
    }),
    selectedCellData: Object.freeze([]),
    shadeUntilCurrentTime: false,
    showAllDayPanel: true,
    showCurrentTimeIndicator: true,
    timeZone: "",
    useDropDownViewSwitcher: false,
    views: Object.freeze(["day", "week"]),
    endDayHour: 24,
    startDayHour: 0,
    firstDayOfWeek: 0,
    cellDuration: 30,
    groups: Object.freeze([]),
    maxAppointmentsPerCell: "auto",
    recurrenceExceptionExpr: "recurrenceException",
    recurrenceRuleExpr: "recurrenceRule",
    startDateExpr: "startDate",
    startDateTimeZoneExpr: "startDateTimeZone",
    endDateExpr: "endDate",
    endDateTimeZoneExpr: "endDateTimeZone",
    allDayExpr: "allDay",
    textExpr: "text",
    allDayPanelMode: "all",
    toolbar: Object.freeze([{
        defaultElement: "dateNavigator",
        location: "before"
    }, {
        defaultElement: "viewSwitcher",
        location: "after"
    }]),
    defaultCurrentDate: Object.freeze(new Date),
    currentDateChange: () => {},
    defaultCurrentView: "day",
    currentViewChange: () => {}
})));
export var DataAccessorsProps = {
    get descriptionExpr() {
        return SchedulerProps.descriptionExpr
    },
    get resources() {
        return SchedulerProps.resources
    },
    get recurrenceExceptionExpr() {
        return SchedulerProps.recurrenceExceptionExpr
    },
    get recurrenceRuleExpr() {
        return SchedulerProps.recurrenceRuleExpr
    },
    get startDateExpr() {
        return SchedulerProps.startDateExpr
    },
    get startDateTimeZoneExpr() {
        return SchedulerProps.startDateTimeZoneExpr
    },
    get endDateExpr() {
        return SchedulerProps.endDateExpr
    },
    get endDateTimeZoneExpr() {
        return SchedulerProps.endDateTimeZoneExpr
    },
    get allDayExpr() {
        return SchedulerProps.allDayExpr
    },
    get textExpr() {
        return SchedulerProps.textExpr
    }
};
export var CurrentViewConfigProps = {
    get crossScrollingEnabled() {
        return SchedulerProps.crossScrollingEnabled
    },
    get groupByDate() {
        return SchedulerProps.groupByDate
    },
    get indicatorUpdateInterval() {
        return SchedulerProps.indicatorUpdateInterval
    },
    get scrolling() {
        return SchedulerProps.scrolling
    },
    get shadeUntilCurrentTime() {
        return SchedulerProps.shadeUntilCurrentTime
    },
    get showAllDayPanel() {
        return SchedulerProps.showAllDayPanel
    },
    get showCurrentTimeIndicator() {
        return SchedulerProps.showCurrentTimeIndicator
    },
    get endDayHour() {
        return SchedulerProps.endDayHour
    },
    get startDayHour() {
        return SchedulerProps.startDayHour
    },
    get firstDayOfWeek() {
        return SchedulerProps.firstDayOfWeek
    },
    get cellDuration() {
        return SchedulerProps.cellDuration
    },
    get maxAppointmentsPerCell() {
        return SchedulerProps.maxAppointmentsPerCell
    },
    get allDayPanelMode() {
        return SchedulerProps.allDayPanelMode
    }
};
