/**
* DevExtreme (ui/tooltip.d.ts)
* Version: 22.2.6 (build 23134-0310)
* Build date: Sun May 14 2023
*
* Copyright (c) 2012 - 2023 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
    Cancelable,
    EventInfo,
    InitializedEventInfo,
    ChangedOptionInfo,
} from '../events/index';

import dxPopover, {
    dxPopoverOptions,
} from './popover';

export type ContentReadyEvent = EventInfo<dxTooltip>;

export type DisposingEvent = EventInfo<dxTooltip>;

export type HidingEvent = Cancelable & EventInfo<dxTooltip>;

export type HiddenEvent = EventInfo<dxTooltip>;

export type InitializedEvent = InitializedEventInfo<dxTooltip>;

export type OptionChangedEvent = EventInfo<dxTooltip> & ChangedOptionInfo;

export type ShowingEvent = Cancelable & EventInfo<dxTooltip>;

export type ShownEvent = EventInfo<dxTooltip>;

/**
 * @deprecated use Properties instead
 * @deprecated Attention! This type is for internal purposes only. If you used it previously, please submit a ticket to our {@link https://supportcenter.devexpress.com/ticket/create Support Center}. We will check if there is an alternative solution.
 */
export interface dxTooltipOptions extends dxPopoverOptions<dxTooltip> {
}
/**
 * The Tooltip UI component displays a tooltip for a specified element on the page.
 */
export default class dxTooltip extends dxPopover<dxTooltipOptions> { }

export type Properties = dxTooltipOptions;

/**
 * @deprecated use Properties instead
 * @deprecated Attention! This type is for internal purposes only. If you used it previously, please submit a ticket to our {@link https://supportcenter.devexpress.com/ticket/create Support Center}. We will check if there is an alternative solution.
 */
export type Options = dxTooltipOptions;
